/**/

   /*     This simply reads 4dosfunctions_long.btm, remove empty lines and comments,                  */
   /*     and saves the rest to 4dosfunctions.btm.                                                    */
   /*     It must be run from the directory where 4dosfunctions_long.btm is located.                  */

   if RxFuncQuery('SysLoadFuncs') then do
         call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
         call SysLoadFuncs
      end

   /*     infile = SysBootDrive()||'\akm\btm\4dosfunctions_long.btm'                                  */
   /*     outfile = SysBootDrive()||'\akm\btm\4dosfunctions.btm'                                      */
   infile = '4dosfunctions_long.btm'
   outfile = '4dosfunctions.btm'
   bakfile = outfile||'.bak'
   if \FileExist(infile) then do
         call lineout 'stderr', 'cannot find' infile
         return 1
      end
   if FileExist(outfile) then do
         if FileExist(bakfile) then
            call SysFileDelete bakfile
         '*ren' outfile bakfile
      end

   call lineout outfile, 'rem   DO NOT EDIT THIS FILE'
   call lineout outfile, 'rem   Edit 4dosfunctions_long.btm instead'
   call lineout outfile, 'rem   then run make4dosfunctions.cmd to make a new 4dosfunctions.btm'
   call lineout outfile, ''
   do while chars(infile) > 0
      aline = linein(infile)
      select
         when strip(aline) = '' then nop
         when translate(word(aline, 1)) == 'REM' then nop
         otherwise
            call lineout outfile, aline
      end
   end
   call lineout outfile
   say 'made new' outfile
   return 0

   FileExist: procedure
   /* =============================================================================================== */
   /*  Usage:                                                                                         */
   /*        if FileExist(<filename>) then                                                            */
   /*                                                                                                 */
   /*  returns 1 (True) if <filename> exists and 0 (False) if it does not.                            */
   /*                                                                                                 */
   /*  <filename> must be a real file. This returns 0 for devices or for streams like STDOUT.         */
   /*  Granted, STDOUT does exist, but it is more useful this way. I mostly use this when I want      */
   /*  to avoid clobbering an existing file,                                                          */
   /*                                                                                                 */
   /*  The main reason for this is that                                                               */
   /*        if FileExist(filename) then                                                              */
   /*  is easier to remember than                                                                     */
   /*         if stream(filename, 'c', 'query exists') then                                           */
   /* =============================================================================================== */
   /*  Most of the complications are because OS/2 Rexx and Regina return different values             */
   /*  from stream() for stdout and for devices. Regina usually returns 0 for stdout, but             */
   /*  not always. I don't know why.                                                                  */
   parse arg FileN
   if FileN = '' then return 0
   if wordpos(translate(FileN), 'STDOUT STDERR') > 0 then return 0
   ret = stream(FileN, 'c', 'query exists')
   if ret == '' then return 0
   if left(translate(ret), 5) == '\DEV\' then return 0
   if left(translate(ret), 5) == '/DEV/' then return 0
   return 1
   /* === End of FileExist ========================================================================== */

